package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ItemDescontoDAO;
import com.rjconsultores.ventaboletos.entidad.ItemDesconto;
import com.rjconsultores.ventaboletos.service.ItemDescontoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("ItemDescontoService")
public class ItemDescontoServiceImpl implements ItemDescontoService {

	@Autowired
	private ItemDescontoDAO itemDescontoDAO;

	@Override
	public List<ItemDesconto> obtenerTodos() {
		return itemDescontoDAO.obtenerTodos();
	}

	@Override
	public ItemDesconto obtenerID(Long id) {
		return itemDescontoDAO.obtenerID(id);
	}

	@Transactional
	@Override
	public ItemDesconto suscribir(ItemDesconto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return itemDescontoDAO.suscribir(entidad);
	}

	@Transactional
	@Override
	public ItemDesconto actualizacion(ItemDesconto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return itemDescontoDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(ItemDesconto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		itemDescontoDAO.actualizacion(entidad);
	}

	@Override
	public List<ItemDesconto> buscarPorNome(String nomitemdesconto) {
		return itemDescontoDAO.buscarPorNome(nomitemdesconto);
	}

}
